-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local im  = ui_imgui

local C = {}

C.name = 'Order Vehicle Switching'
C.description = 'Order Vehicle Switching by race placement.'
C.category = 'repeat_instant'

C.color = im.ImVec4(1, 1, 0, 0.75)
C.pinSchema = {
  {dir = 'in', type = 'table', name = 'raceData', tableType = 'raceData', description = 'Data from the race for other nodes to process.'}
}

C.tags = {'scenario'}

function C:work(args)
  local race = self.pinIn.raceData.value
  if not race then return end

  -- race.statesのplacementをキーにvehicleOrderを作成
  local vehicleOrder = {}
  for vehicleId, states in pairs(race.states) do
    if states.placement ~= nil then
      vehicleOrder[states.placement] = vehicleId
    end
  end

  -- vehicleOrderのキーを1から順に振り直す
  local newVehicleOrder = {}
  local i = 1
  for _, vehicleId in pairs(vehicleOrder) do
    newVehicleOrder[i] = vehicleId
    i = i + 1
  end

  core_input_vehicleSwitching.setVehicleOrder(newVehicleOrder)
  -- log('D', 'orderVehicleSwitchingByRacePlacementNode', 'vehicleOrder: ' .. dumps(newVehicleOrder))
end

return _flowgraph_createNode(C)
