-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local im  = ui_imgui

local C = {}

C.name = 'Set Race Branching Config'
C.description = 'Set race branching config.'
C.category = 'repeat_instant'

C.color = im.ImVec4(1, 1, 0, 0.75)
C.pinSchema = {
  { dir = 'in', type = 'table', name = 'raceData', tableType = 'raceData', description = 'Race data' },
  { dir = 'in', type = 'bool', name = 'enableBanching', description = 'Force using branching config.'},
}

C.tags = {'scenario'}

function C:work(args)
  local race = self.pinIn.raceData.value
  if not race then return end

  if self.pinIn.enableBanching then
    -- hotlappingでのエラー回避のため、watchingAIModeの時は常にbranchingをtrueにする必要がある。
    race.path.config.branching = true
  end
end

return _flowgraph_createNode(C)
