-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local im  = ui_imgui

local C = {}

C.name = 'Setup AI racer ID table'
C.description = 'Setup AI racer ID table.'
C.category = 'once_instant'
C.color = im.ImVec4(0.4, 0.9, 1.0, 0.9)
C.author = 'mathkuro'
C.tmpSecondPassFlag = true
C.pinSchema = {
  {dir = 'in', type = 'table', name = 'vehIdTable', description = 'Vehicle id table.'},
  {dir = 'in', type = 'number', name = 'playerId', description = 'Player vehicle ID.'},
  {dir = 'in', type = 'bool', name = 'watchingAIMode', description = 'Use watching AI mode or not.'},
  {dir = 'out', type = 'table', name = 'racerIdTable', description = 'Racer ID table.'}
}

C.tags = {}

function C:workOnce()
  local racerIDTable = {}
  if self.pinIn.watchingAIMode.value then
    table.insert(racerIDTable, self.pinIn.playerId.value)
  end

  if self.pinIn.vehIdTable.value ~= nil then
    for _, vid in pairs(self.pinIn.vehIdTable.value) do
      table.insert(racerIDTable, vid)
    end
  end

  self.pinOut.racerIdTable.value = racerIDTable
end

return _flowgraph_createNode(C)
